stages:
- build
- test
- deploy

image: node:16-alpine

variables:
  BUCKET_NAME: ingesys-unix-cicd-serviceweb
  USER: eric

cache:
  paths:
  - node_modules

Install dependencies:
  stage: build
  script:
  - npm install

# Run server:
#   stage: build
#   script:
#   - node app.js & # exécution en mode "détaché". Souci: on ne sait pas si une erreur se produit au démarrage

Test server:
  stage: test
  before_script:
  - apk add curl # installation de curl sur alpine
  script:
  - node app.js &
  - sleep 10
  - curl http://localhost:3000 | grep "World"
  #- curl -Is http://localhost:3000/help | head -n 1 | grep 200 # test l'existence du endpoint

Deliver to AWS S3:
  stage: deploy
  image: 
    name: banst/awscli
    entrypoint: [""]
  script:
  - aws --version 
  #- aws s3 ls
  - aws s3 cp app.js s3://$BUCKET_NAME/$USER/
  - aws s3 cp package.json s3://$BUCKET_NAME/$USER/